const { desktopCapturer, ipcRenderer } = require('electron');



function addSource(displayJqItem, source) {
    $(displayJqItem).find("#nav-windowShare").append("<img src='" + source.thumbnail.toDataURL() + "' class='desktopIcon' width='50' height='50' data-src-id='" + source.id + "' />");
}

function addDesktopShareSource(displayJqItem, source) {
    var html = "<div class='screenshareContainer'>" +
        "<img src='" + source.thumbnail.toDataURL() + "' class='desktopIcon' width='50' height='50' data-src-id='" + source.id + "' />"
        + "</div>";
    $(displayJqItem).find("#nav-screenShare").append(html);
}



function getTemplate() {
    var html = "<div role='navigation'>"
        + "<ul class='nav nav-tabs' role='tablist'>"
        + "<li role='presentation' class='nav-item'>"
        + "<a  href='#' data-target='#nav-screenShare' aria-controls='Screen' role='tab' data-toggle='tab' data-id='nav-screenShare' id='fullScreenTab'>Select Screen</a>"
        + "</li>"
        + "<li role='presentation' class='nav-item'>"
        + "<a  href='#' data-target='#nav-windowShare' aria-controls='Window' role='tab' data-toggle='tab' data-id='nav-windowShare' id='windowShareTab'>Select Window</a>"
        + "</li>"
        + "</ul>"
        + "</div>"
        + "<div class='tab-content tabBorder'>"
        + "<div role='tabpanel' class='tab-pane fade in active' id='nav-screenShare' aria-labelledby='fullScreenTab'>"
        + "</div>"
        + "<div role='tabpanel' class='tab-pane fade' id='nav-windowShare' aria-labelledby='windowShareTab'>"
        + "</div>"

        + "</div>";
    return html;
}



function showSources(displayJqItem, callback) {
    console.log("show sources is called!");
    $(displayJqItem).html(getTemplate());
    desktopCapturer.getSources({ types: ['window', 'screen'], thumbnailSize: { width: 700, height: 700 } }).then(
        function (sources, error) {
            for (var i = 0; i < sources.length; i++) {
                var source = sources[i];
                console.log("Name: " + source.name);
                if (i == 0) {
                    addDesktopShareSource(displayJqItem, source);
                } else {
                    addSource(displayJqItem, source);
                }
            }
            if (callback) {
                callback();
            }
        }
    );
}

window.onload = () => {
    console.log("window onload [Preload]====>>>");
    $(document).ready(function () {
        console.log("Document is ready [Preload]====>>>");
        window.interop = {
            handleScreenShare: function (displayJqItem, callback) {
                console.log("room page desktop sharing selection has changed");
                showSources(displayJqItem, callback);
            },
            showChatNotification: function (room) {
                console.log("[******Electron] Got RoomMessageEvent, current room ", room);
                ipcRenderer.send('asynchronous-message', room)
            }
        };
    });
}